#include "stdafx.h"
#include "../Engine/Sockets/TaskProcessorSockets.h"

//////////////////////////////////////////////////////////////////////
// Constructor
CEmEngine::CEmEngine() 
	:m_hStop(NULL)
	,m_hWndUI(NULL)
	,m_eXmlState(XML_DISCONNECTED)
{
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// start
bool CEmEngine::Init(HWND hWndUI)
{
	m_hWndUI = hWndUI;
	//	Create an Event which can be asserted to stop the Engine. If successful...
	if (m_hStop = CreateEvent(NULL, TRUE, FALSE, NULL))
	{
		//	Initialize the Sockets TaskProcessor
		m_pSocketsProcessor = new CTaskProcessor_Sockets;
		if (m_pSocketsProcessor->Init())
		{
			//	Initialize the TCP "Engine".
			if (m_pSocketsProcessor->m_stTcp.Init())
			{
				// add relevant interfaces
				//m_stTcp.AddInterface(80, T_CLIENT_WEB);
				//m_stTcp.AddInterface(7821, T_CLIENT_PEER);
			}
			else
			{
				ASSERT(FALSE);
				AddDebugLogLine("Failed to initialize TCP engine");
				return false;
			}
		}
		else
		{
			ASSERT(FALSE);
			AddDebugLogLine("Failed to initialize sockets processor");
			return false;
		}

		return true;
	}
	else
	{
		ASSERT(FALSE);
		AddDebugLogLine("CreateEvent failed");
		return false;
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// stop
void CEmEngine::Uninit()
{
	if (m_hStop)
	{
		if (!SetEvent(m_hStop))
		{
			ASSERT(FALSE);
			AddDebugLogLine("SetEvent failed");
		}

		m_pSocketsProcessor->m_stTcp.Uninit(false);
		m_pSocketsProcessor->Uninit();

		m_pSocketsProcessor->m_stTcp.Uninit(); // final
		delete m_pSocketsProcessor;

		if (!CloseHandle(m_hStop))
		{
			ASSERT(FALSE);
			AddDebugLogLine("CloseHandle failed");
		}
		m_hStop = NULL;
	}
}

void CEmEngine::SetXmlResponse(ULONG ulId, LPCTSTR sResponse)
{
//	CMutexLock stLock(m_mutexXmlResponses, true);
	m_stXmlResponses[ulId] = sResponse;
//	stLock.Unlock();
}

// This can be implemented better
CString CEmEngine::WaitForXmlResponse(ULONG ulId, DWORD dwTimeout)
{
	DWORD dwStart = GetTickCount();
	while(GetTickCount() - dwStart < dwTimeout)
	{
		if(WaitForSingleObject(m_hStop, 100) != WAIT_TIMEOUT)
			return _T("");
//		CMutexLock stLock(m_mutexXmlResponses, true);
		XmlRespMap::iterator it = m_stXmlResponses.find(ulId);
		if(it != m_stXmlResponses.end())
		{
			CString sRes = m_stXmlResponses[ulId];
			m_stXmlResponses.erase(ulId);
//			stLock.Unlock();
			return sRes;
		}
//		stLock.Unlock();
	}
	return _T("");
}
