#pragma once

#include "../Loggable.h"

#define WM_UI_STATE	(WM_USER + 1)

enum XmlStates
{
	XML_CONNECTED,
	XML_DISCONNECTED
};

struct CTask;
struct CEmClient;
struct CTcpCompletionTask;
struct CEmClient;
struct CEmClient_Xml;
class CTaskProcessor_Sockets;

class CEmEngine : public CLoggable
{
	HANDLE	m_hStop; // termination event
	HWND	m_hWndUI;

public:

	CEmClient_Xml*	m_pXmlClient;

	CEmEngine();
	~CEmEngine() { Uninit(); }

	bool Init(HWND hWndUI);
	void Uninit();

	inline bool IsShuttingDown()
	{
		return WAIT_TIMEOUT != WaitForSingleObject(m_hStop, 0); 
	}
	inline void SetXmlState(XmlStates eState, DWORD dwData = 0)
	{
		m_eXmlState = eState;
		if(m_hWndUI)
			::PostMessage(m_hWndUI, WM_UI_STATE, (WPARAM)eState, (LPARAM)dwData);
	}
	inline XmlStates GetXmlState(){ return m_eXmlState; }

	__declspec(property(get=_GetSocketsProcessor))	CTaskProcessor_Sockets&	Sockets;
	CTaskProcessor_Sockets&	_GetSocketsProcessor()	{ if(!m_pSocketsProcessor)throw;return *m_pSocketsProcessor; }

	void SetXmlResponse(ULONG ulId, LPCTSTR sResponse);
	CString WaitForXmlResponse(ULONG ulId, DWORD dwTimeout = 5000);

private:
	CTaskProcessor_Sockets*	m_pSocketsProcessor;

	typedef map<ULONG, CString> XmlRespMap;
	XmlRespMap	m_stXmlResponses;
	XmlStates	m_eXmlState;
	CMutex		m_mutexXmlResponses;
};
