#include "types.h"

#pragma once

class CPartFile;
class CUpDownClient;

class CSourceSaver
{
public:
	CSourceSaver(void);
	~CSourceSaver(void);
	bool Process(CPartFile *file, int maxSourcesToSave = 10, bool bIgnoreTimer = false);
	void LoadSources(CPartFile *file);

protected:
	class CSourceData
	{
	public:
		CSourceData(uint32 dwID, uint16 uPort, const char *exp);
#ifndef NEW_SOCKETS_ENGINE
		CSourceData(CUpDownClient *pClient, const char *exp);
#endif //NEW_SOCKETS_ENGINE
		CSourceData(CSourceData *pOld);

		bool Compare(CSourceData* tocompare) {						return ((sourceID == tocompare->sourceID) 
																	 && (sourcePort == tocompare->sourcePort)); }

		uint32	sourceID;
		uint32	partsavailable;
		uint16	sourcePort;
		char	expiration[7];
	};
	typedef CTypedPtrList<CPtrList, CSourceData*> SourceList;

	void LoadSourcesFromFile(CPartFile* file, SourceList* sources, const CString& slsfile);
	void SaveSources(CPartFile* file, SourceList* prevsources, const CString& slsfile, int maxSourcesToSave);
	void AddSourcesToDownload(CPartFile* file, SourceList* sources);
	
	uint32	m_dwLastTimeLoaded;
	uint32	m_dwLastTimeSaved;
	
	CString CalcExpiration(int nDays);
	bool IsExpired(const CString &strExpirationDate);
};
